/**
 Copyright 2014 Gordon Williams (gw@pur3.co.uk)

 This Source Code is subject to the terms of the Mozilla Public
 License, v2.0. If a copy of the MPL was not distributed with this
 file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
 ------------------------------------------------------------------
  'About' Settings Page 
 ------------------------------------------------------------------
**/
"use strict";
(function(){
  
  function getVersion(callback) {
    if (typeof process === 'undefined') {
      // Web Browser
      Espruino.Core.Utils.getJSONURL('manifest.json',function (manifest) {
        callback(manifest.version);
      });
    } else {
      // Node
      var pjson = require('./package.json');
      callback(pjson.version);
    }
  }

  function init() {
    getVersion(function(version) {
      Espruino.Core.Config.addSection("About", {
        description : "About the Espruino Web IDE v"+ version,
        sortOrder : -1000,
        getHTML : function(callback) {      
          Espruino.Core.Utils.getURL("data/settings_about.html", function(data) {
            callback(data);
            var html;
            if (Object.keys(Espruino.Core.Env.getBoardData()).length > 0)
              html = Espruino.Core.Utils.htmlTable(Espruino.Core.Env.getBoardData());
            else
              html = "<p>Unable to get board information. Please connect to an Espruino board first.</p>";
            $('.board_info').html( html );
          });
        }
      });
    });    
  }
  
  Espruino.Core.SettingsAbout = {
    init : init,
  };
}());
